import processing.core.*; 
import processing.xml.*; 

import ddf.minim.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class recordings extends PApplet {

/**
 *   Interruptions recored by Lindsay Grace 
 * the sketch.
 */



Minim minim;
AudioInput in;
AudioRecorder[] recorder=new AudioRecorder[100];
int intCounter=0;
float intLastLeft=0;
float intLastLeftValue=0;
int intFrameCounter = 0;
public void setup()
{
  size(512, 200, P3D);
  textMode(SCREEN);

  //font = loadFont("FFScala-32.vlw");
  //textFont(font);

  minim = new Minim(this);

  // get a stereo line-in: sample buffer length of 2048
  // default sample rate is 44100, default bit depth is 16
  in = minim.getLineIn(Minim.STEREO, 2048);
  // create a recorder that  will record from the input to the filename specified, using buffered recording
  // buffered recording means that all captured audio will be written into a sample buffer
  // then when save() is called, the contents of the buffer will actually be written to a file
  // the file will be located in the sketch's root folder.
  recorder[0] = minim.createRecorder(in, "c:\\data\\myrecording" + intCounter +".wav", true);
  // recorder[intCounter].beginRecord();
  textFont(createFont("Arial", 12));
}

public void draw()
{
  background(0);
  stroke(255);
  // draw the waveforms
  // the values returned by left.get() and right.get() will be between -1 and 1,
  // so we need to scale them up to see the waveform
  for(int i = 0; i < in.bufferSize() - 1; i++)
  {
    //text("a", 15, 60);
    //text("a", 15, 60);
    //text("A", 50 + in.left.get(i)*50, i+1, 50 + in.left.get(i+1)*500);
    //text("a", 150 + in.right.get(i)*50, i+1, 150 + in.right.get(i+1)*500);

    line(i, 50 + in.left.get(i)*50, i+1, 50 + in.left.get(i+1)*50);
    line(i, 150 + in.right.get(i)*50, i+1, 150 + in.right.get(i+1)*50);

    intLastLeft = in.left.get(i+1)*100;
  }
  intFrameCounter++;
  //if (recorder[intCounter].isRecording()){
  if (abs (intLastLeft - intLastLeftValue) > 25){
    if (intCounter == 0) {
      File dir = new File("c:\\data\\");

      String[] children = dir.list();
      if (children == null) {
        // Either dir does not exist or is not a directory
      } 
      else {
        for (int i=0; i<children.length; i++) {
          String filename = children[i];
          boolean success = (new File("c:\\data\\"+filename)).delete();
          if (success){
                      println ("deleted" + filename);
            
          }else{
             println ("did not delete" + filename); 
          }
          // Get filename of file or directory
          //
        }
      }

      // processing.app.Base
    }
    //end if

    text("NEW file .", 5, 55);
    recorder[intCounter].endRecord();
    recorder[intCounter].save();
    println("Done saving.");
    intCounter = intCounter + 1;
    if (intCounter > 99){
      intCounter = 0;
    }

    recorder[intCounter] = minim.createRecorder(in, "c:\\data\\myrecording" + intCounter +".wav", true);
    recorder[intCounter].beginRecord();
    intFrameCounter=0;
  }
  //}
  intLastLeftValue=intLastLeft;

  if ( recorder[intCounter].isRecording() )
  {
    text("Currently recording...", 5, 15);
  }
  else
  {
    text("Not recording.", 5, 15);
  }
}

public void keyReleased()
{
  int i=0;
  if ( key == 'r' )
  {
    // to indicate that you want to start or stop capturing audio data, you must call
    // beginRecord() and endRecord() on the AudioRecorder object. You can start and stop
    // as many times as you like, the audio data will be appended to the end of the buffer
    // (in the case of buffered recording) or to the end of the file (in the case of streamed recording).
    if ( recorder[intCounter].isRecording() )
    {
      //  recorder[intCounter].endRecord();
    }
    else
    {
      //  recorder[intCounter].beginRecord();
    }
  }
  if ( key == 's' || intFrameCounter > 50)
  {
    // we've filled the file out buffer,
    // now write it to the file we specified in createRecorder
    // in the case of buffered recording, if the buffer is large,
    // this will appear to freeze the sketch for sometime
    // in the case of streamed recording,
    // it will not freeze as the data is already in the file and all that is being done
    // is closing the file.
    // the method returns the recorded audio as an AudioRecording,
    // see the example  AudioRecorder >> RecordAndPlayback for more about that
    /* for (i=0;i<intCounter;i++){
     recorder[i].save();
     println("Done saving.");
     }*/
     intCounter = 0;
     println ("Done recording" );
     for(i=0;i<=intCounter;i++){
       recorder[intCounter].endRecord(); 
     }
  }
}

public void stop()
{
  // always close Minim audio classes when you are done with them
  in.close();
  minim.stop();

  super.stop();
}



  static public void main(String args[]) {
    PApplet.main(new String[] { "recordings" });
  }
}
